#!/bin/sh

#install requirements
case "$(uname -s)" in
  CYGWIN*|MINGW32*|MSYS*|MINGW*)
    py.exe -m pip install --upgrade pip
    pip3 install grpcio-tools
  ;;

  *)
    python3 -m pip install --upgrade pip
    pip3 install grpcio-tools
  ;;
esac

# paths
MC_ROOT=../../../../..
MC_API=$MC_ROOT/api/proto
MCD_API=$MC_ROOT/mobilecoind/api/proto
CONSENSUS_API=$MC_ROOT/consensus/api/proto

# compile protobuf for python
case "$(uname -s)" in
  CYGWIN*|MINGW32*|MSYS*|MINGW*)
    py.exe -m grpc_tools.protoc -I$MC_API --python_out=. $MC_API/external.proto
    py.exe -m grpc_tools.protoc -I$MC_API --python_out=. $MC_API/blockchain.proto
    py.exe -m grpc_tools.protoc -I$MCD_API -I$CONSENSUS_API -I$MC_API --python_out=. --grpc_python_out=. $MCD_API/mobilecoind_api.proto
  ;;

  *)
    python3 -m grpc_tools.protoc -I$MC_API --python_out=. $MC_API/external.proto
    python3 -m grpc_tools.protoc -I$MC_API --python_out=. $MC_API/blockchain.proto
    python3 -m grpc_tools.protoc -I$MCD_API -I$CONSENSUS_API -I$MC_API --python_out=. --grpc_python_out=. $MCD_API/mobilecoind_api.proto
  ;;
esac

# the autogenerated files need to be modified for the module to work
# see: https://github.com/protocolbuffers/protobuf/issues/1491

# TODO: extend this script to automatically fix the imports to be relative.
# for now I am doing this by hand for expediency

# possible fix from the tracking issue
# sed -i -E 's/^import.*_pb2/from . \0/' *.py

# change all `import a_pb2` to `from . import a_pb2`
